#include <stdio.h>

static char rcsid[]="$Id: split_pp.c,v 1.2 1989/10/16 13:17:36 waite Exp $";
/* Copyright, 1989, The Regents of the University of Colorado */

main(argc,argv)
int argc; char *argv[];
/* Copy PROPP macros into distinct files
 *    On entry-
 *       argv[1]=name of a file containing PROPP macros
 *    On exit-
 *       The text of macro EXT_xxx has been appended to file xxx
 *          for all xxx
 * "#line" directives for cpp are added to the output files
 * to identify the source of the macro text.
 * (This facility is commented out in the current version because the
 * Berkeley Pascal compiler does not accept #line directives.)
 */
{
	char line[BUFSIZ], macname[5], *p, *q;
	int count, i;
	FILE *f, *macro, *fopen();

	if (argc != 2) {
		(void)fprintf(stderr, "Usage %s file\n", argv[0]);
		exit(1);
	}
	f = fopen(argv[1], "r");
	macro = NULL;
	count = 1;
	while (fgets(line, BUFSIZ, f) != NULL) {
		if (strncmp(line, "&MACRO EXT_", 11) == 0) {
			if (macro != NULL) (void)fclose(macro);
			p = macname; q = &line[11];
			for (i = 1; i <= 4; i++) *p++ = *q++;
			*p = '\0';
			if ((macro = fopen(macname, "a")) == NULL) {
				(void)fprintf(stderr, "%s open failed\n", &line[11]);
				exit(1);
			}
/*
			(void)fprintf(macro, "#line %d \"%s\"\n", count+1, argv[1]);
*/
		} else if (macro == NULL) {
			(void)fprintf(stderr, "&MACRO line missing on %s\n", argv[1]);
			exit(1);
		} else {
			fputs(line, macro);
		}
		count++;
	}
}
